! A B C I n  c l u d e F i l e
! TList Class

TLCHK_APPEARANCE_FLAT    Equate(0)
TLCHK_APPEARANCE_3D      Equate(1)
TLCHK_APPEARANCE_CUSTOM  Equate(2)

EDITMODE_NONE                       Equate(0000h)
EDITMODE_TREE_ITEMS                 Equate(0001h)
EDITMODE_GRID_CELLS                 Equate(0002h)
EDITMODE_GRID_ROW_CAPTIONS          Equate(0004h)
EDITMODE_GRID_COL_CAPTIONS          Equate(0008h)
EDITMODE_START_ON_CLICK             Equate(0010h)
TLEDITINFO_TEXTBOX                  Equate(0)
TLEDITINFO_CHECKBOX                 Equate(1)
TLEDITINFO_COMBOBOX                 Equate(2)
TLEDITINFO_SPIN                     Equate(3)
TLEDITINFO_DATE_TIME                Equate(4)

TLTEXTBOX_OPT_AUTOWIDTH             Equate(00001h) ! Automatically resize width
TLTEXTBOX_OPT_AUTOHEIGHT            Equate(00002h) ! Automatically resize height
TLTEXTBOX_OPT_UPPERCASE             Equate(00008h) ! Convert to uppercase
TLTEXTBOX_OPT_LOWERCASE             Equate(00010h) ! Convert to lowercase
TLTEXTBOX_OPT_PASSWORD              Equate(00020h) ! Display asterisks
TLTEXTBOX_OPT_AUTOVSCROLL           Equate(00040h) ! Scroll vertically
TLTEXTBOX_OPT_AUTOHSCROLL           Equate(00080h) ! Scroll horizontally
TLTEXTBOX_OPT_STDCOLORS             Equate(00100h) ! Use standard colors
TLTEXTBOX_OPT_BORDER                Equate(00200h) ! Draw border
TLTEXTBOX_OPT_VSCROLLER             Equate(00400h) ! Displays vertical scrollbar
TLTEXTBOX_OPT_HSCROLLER             Equate(02000h) ! Displays horizontal scrollbar
TLTEXTBOX_OPT_NOMENU                Equate(04000h) ! Disable context menu
TLTEXTBOX_OPT_FULLRECT              Equate(08000h) ! Expand upto grid cell size

TLCOMBO_DROP_DOWN                   Equate(0) ! Dropdown Combo
TLCOMBO_SIMPLE                      Equate(1) ! Simple Combo
TLCOMBO_DROP_DOWN_LIST              Equate(2) ! Dropdown List

TLCOMBO_OPT_SHOWLIST                Equate(002h) ! Show drop-down list
TLCOMBO_OPT_EDITAREA_AUTOWIDTH      Equate(100h) ! Automatically resize width
TLCOMBO_OPT_CASESENSITIVITY         Equate(200h) ! Text is case sensitivity
TLCOMBO_OPT_EDITAREA_FIT_IN_CELL    Equate(400h) ! Fit in cell
TLCOMBO_OPT_EDITAREA_USE_CELL_VALUE Equate(800h) ! Data in edit box

TL_ACTIVMODE_ITEM                   Equate(0) ! (Default). Activation on item-by-item basis.
TL_ACTIVMODE_ROW                    Equate(1) ! Activation/selection on row-by-row basis.
TL_ACTIVMODE_CELL                   Equate(2) ! Activation/selection on cell-by-cell basis
TL_ACTIVMODE_MIXED                  Equate(3) ! Combination

TLEDITABLE_DEFAULT                  Equate(0) ! Whether or not the cell will be editable depends on EditingMode property flags or can be controlled by ItemEditText and CellEdit properties.
TLEDITABLE_NEVER                    Equate(1) ! The cell can't be edited using in-place editors regardless of the settings of the EditingMode property. This setting also prevents editing using CellEdit and ItemEditText properties.
TLEDITABLE_ALWAYS_ONCLICK           Equate(2) ! The cell is always editable; editing is automatically started as soon as user clicks over the cell.
TLEDITABLE_ALWAYS_ONDBLCLICK        Equate(3) ! The cell is always editable; editing is automatically started as soon as user double clicks over the cell.

TL_EDITTEXT_CANCEL         Equate(0) ! Cancel editing of the grid cell.
TL_EDITTEXT_END            Equate(1) ! Conclude editing of the grid cell.
TL_EDITTEXT_BEGIN          Equate(2) ! Start editing of the grid cell.
TLEDITMODE_CONTINUE        Equate(3) ! Continue editing. This setting may be used within the GridCellAfterEditing event.

TLTEXTALIGNMENT_NOT_VISIBLE   Equate(0) ! Text is not displayed.
TLTEXTALIGNMENT_LEFT_TOP      Equate(1) ! Text is left/top aligned.
TLTEXTALIGNMENT_LEFT_MIDDLE   Equate(2) ! Text is left/middle aligned.
TLTEXTALIGNMENT_LEFT_BOTTOM   Equate(3) ! Text is left/bottom aligned.
TLTEXTALIGNMENT_CENTER_TOP    Equate(4) ! Text is center/top aligned.
TLTEXTALIGNMENT_CENTER_MIDDLE Equate(5) ! Text is center/middle aligned.
TLTEXTALIGNMENT_CENTER_BOTTOM Equate(6) ! Text is center/bottom aligned.
TLTEXTALIGNMENT_RIGHT_TOP     Equate(7) ! Text is right/top aligned.
TLTEXTALIGNMENT_RIGHT_MIDDLE  Equate(8) ! Text is right/middle aligned.
TLTEXTALIGNMENT_RIGHT_BOTTOM  Equate(9) ! Text is right/bottom aligned.

TLNODERELATION_FIRST          Equate(0) ! First. The Node is placed before all other nodes at the same level of the node named in DestIndex parameter. In other words it becomes the first child of the same parent as the DestIndex node.
TLNODERELATION_LAST           Equate(1) ! Last. The Node is placed after all other nodes at the same level of the node named in DestIndex parameter.
TLNODERELATION_NEXT           Equate(2) ! Next. The Node is placed immediately after the node named in DestIndex parameter.
TLNODERELATION_PREVIOUS       Equate(3) ! Previous. The Node is placed before the node named in DestIndex parameter
TLNODERELATION_CHILD          Equate(4)


TListColumns        Queue,Type
ColTitle               CString(128)
ColWidth               Short
                    End

! **********************************************************************************************
! TList class
! **********************************************************************************************

TList        CLASS,Type,MODULE('TListL.lib'),LINK('TListL.lib')

              ! Properties -----------------------------------------------------------------------

W                          &Window
cOLE                       Short
QColumns                   &TListColumns
ColCount                   Byte
DescSize                   &Short
WrapSize                   &Short

              ! Methods -------------------------------------------------------------------------

Init                       Procedure(Window W,Short OLEControl),Proc,VIRTUAL
Init                       Procedure(Window W,Short OLEControl,Byte ColCount,*Short,*Short),Proc,VIRTUAL
Kill                       Procedure(),Proc,VIRTUAL
Activate                   Procedure(LONG RowIndex, LONG ColIndex),VIRTUAL
ActivationMode             Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
AddItem                    Procedure(? item ,<SHORT index>),VIRTUAL
AutoDragMode               Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
CellBackColor              Procedure(Long RowNum,Long ColNum,<Long Color>),LONG,PROC,VIRTUAL
CellForeColor              Procedure(Long RowNum,Long ColNum,<Long Color>),LONG,PROC,VIRTUAL
CheckBoxValue              Procedure(Long RowNum,Long ColNum,<? Value>),?,PROC,VIRTUAL
ColDelimiter               Procedure(<SHORT character_code>),SHORT,PROC,VIRTUAL
ColumnCheckedPicture       Procedure(Long ColNum,STRING ImageFile),VIRTUAL
ColumnUncheckedPicture     Procedure(Long ColNum,STRING ImageFile),VIRTUAL
ColumnVisible              Procedure(Long ColNum,<LONG Flag>),LONG,PROC,VIRTUAL
ComboBoxDropDownItemHeight Procedure(Long Col,<LONG pixels>),LONG,PROC,VIRTUAL
ComboBoxItemsAdd           Procedure(Long Col, STRING Value, <STRING ImageFile >),VIRTUAL
ComboBoxOptions            Procedure(Long Col,<LONG Options>),LONG,PROC,VIRTUAL
ComboBoxStyle              Procedure(LONG Col, <LONG enum>),LONG,PROC,VIRTUAL
ConvertTabsToCols          Procedure(<LONG Value>),LONG,PROC,VIRTUAL
DefItemCellBackColor       Procedure(<LONG Value>),LONG,PROC,VIRTUAL
DeselectAll                Procedure(),VIRTUAL
DeselectCell               Procedure(LONG Row, LONG Col),VIRTUAL
EditingMode                Procedure(<LONG Value>),LONG,PROC,VIRTUAL
EditInfoStyle              Procedure(LONG Col, <LONG enum>),LONG,PROC,VIRTUAL
FocusRectStyle             Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
GridCols                   Procedure(<LONG NumberOfCols>),LONG,PROC,VIRTUAL
GridColDefsWidth           Procedure(LONG Col, <LONG xsize>),LONG,PROC,VIRTUAL
GridRows                   Procedure(<LONG NumberOfRows>),LONG,PROC,VIRTUAL
ItemFontBold               Procedure(SHORT index, <LONG Value>),LONG,PROC,VIRTUAL
ItemFontItalic             Procedure(SHORT index, <LONG Value>),LONG,PROC,VIRTUAL
ItemFontStrike             Procedure(SHORT index, <LONG Value>),LONG,PROC,VIRTUAL
ItemFontUnder              Procedure(SHORT index, <LONG Value>),LONG,PROC,VIRTUAL
ItemFontName               Procedure(SHORT index, <STRING Value>),STRING,PROC,VIRTUAL
ItemFontSize               Procedure(SHORT index, <STRING Value>),STRING,PROC,VIRTUAL
ItemGridCols               Procedure(SHORT ItemIndex, <LONG NumberOfCols>),LONG,PROC,VIRTUAL
ItemGridRows               Procedure(SHORT ItemIndex, <LONG NumberOfRows>),LONG,PROC,VIRTUAL
KeyboardActivation         Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
MouseCol                   Procedure(),LONG,VIRTUAL
MouseRow                   Procedure(),LONG,VIRTUAL
MultiLine                  Procedure(LONG Col, <LONG enum>),LONG,PROC,VIRTUAL
MultiSelect                Procedure(<LONG enum>),LONG,PROC,VIRTUAL
NewIndex                   Procedure(),LONG,VIRTUAL
RowBackColor               Procedure(Long RowNum,<Long Color>),LONG,PROC,VIRTUAL
RowForeColor               Procedure(Long RowNum,<Long Color>),LONG,PROC,VIRTUAL
SelectCell                 Procedure(LONG Row, LONG Col),VIRTUAL
SelectColumn               Procedure(LONG Col),VIRTUAL
SelectionMode              Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
SelectionOptions           Procedure(<SHORT enum>),SHORT,PROC,VIRTUAL
SelectRow                  Procedure(LONG Row),VIRTUAL
SetColumn                  Procedure(Long ColNum,String ColTitle,Short ColWidth),VIRTUAL
SetColumnWidth             Procedure(Long ColNum,Short ColWidth),VIRTUAL
TextAlignment              Procedure(LONG Col, <LONG enum>),LONG,PROC,VIRTUAL
TextBoxMaxLength           Procedure(Long Col,<LONG MaxLength>),LONG,PROC,VIRTUAL
TextBoxOptions             Procedure(Long Row,<LONG Options>),LONG,PROC,VIRTUAL
GetColumnWidth             Procedure(Long ColNum),Short,VIRTUAL
SetCellPicture             Procedure(Long RowNum,Long ColNum,STRING ImageFile),VIRTUAL
SetCellValue               Procedure(Long RowNum,Long ColNum,? CellValue),VIRTUAL
GetCellValue               Procedure(Long RowNum,Long ColNum),String,VIRTUAL
AddCellValue               Procedure(Long RowNum,Long ColNum,? CellValue),VIRTUAL
AddComboValue              Procedure(Long ColNum,String ComboValue),VIRTUAL
ClearComboValues           Procedure(Long ColNum),VIRTUAL
ShowTitle                  Procedure(),Proc,VIRTUAL
ClearList                  Procedure(),Proc,VIRTUAL
AddRowString               Procedure(String RowText),Proc,VIRTUAL
AddRow                     Procedure(Long AddOrder,? v1,? v2,? v3,? v4,? v5),Proc,VIRTUAL
RemoveRow                  Procedure(Long RowNum),Proc,VIRTUAL
SetRedraw                  Procedure(Byte RedrawOn),Proc,VIRTUAL
Row                        Procedure(),Long,VIRTUAL
Col                        Procedure(),Long,VIRTUAL
SetActiveCell              Procedure(Long RowNum,Long ColNum),Proc,VIRTUAL
Rows                       Procedure(),Long,VIRTUAL
Update                     Procedure(Byte Request),Proc,VIRTUAL
TakeOCXEvent               Procedure(String EventName,String Params,String P1,String P2,String P3,String P4,String P5),VIRTUAL
SetFocus                   Procedure(),Proc,VIRTUAL
IsChecked                  Procedure(Long RowNum,Long ColNum),Byte,VIRTUAL
MoveUp                     Procedure(Long RowNum),Proc,VIRTUAL
MoveDown                   Procedure(Long RowNum),Proc,VIRTUAL
MoveFirst                  Procedure(Long RowNum),Proc,VIRTUAL
MoveLast                   Procedure(Long RowNum),Proc,VIRTUAL
SetUppercase               Procedure(Byte InUpper),Proc,VIRTUAL
GetObjectProperty          Procedure(SHORT OleControl, STRING Obj, STRING Property),STRING,VIRTUAL
SetObjectProperty          Procedure(SHORT OleControl, STRING Obj, STRING Property, STRING Value),VIRTUAL
                End
